/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JPanel.java to edit this template
 */
package CashManagement;

import Service.MaterialService;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DateFormat;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.Timer;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import model.Material;

/**
 *
 * @author KHANOMMECOM
 */
public class CashPanel extends javax.swing.JPanel {

    List<Material> mtrList;
    MaterialService materialService = new MaterialService();
    DefaultTableModel mtrModel;
    DefaultTableModel PayModel;

    /**
     * Creates new form DarfCashPanel
     */
    public CashPanel() {
        initComponents();
        setTotal();
        getDateTime();
        tblMtr.getTableHeader().setFont(new Font("Tahoma", Font.BOLD, 18));
        tblPayment.getTableHeader().setFont(new Font("Tahoma", Font.BOLD, 14));
        tblMtr.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tblPayment.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        UIManager.put("OptionPane.messageFont", new Font("Tahoma", Font.BOLD, 14));
        mtrModel = (DefaultTableModel) tblMtr.getModel();
        PayModel = (DefaultTableModel) tblPayment.getModel();
        mtrList = materialService.getMaterials();
        for (Material m : mtrList) {
            mtrModel.addRow(new Object[]{m.getMtrID(), m.getMtrName(), m.getMtrPrice()});
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnlMtrTable = new javax.swing.JPanel();
        scpMtrTable = new javax.swing.JScrollPane();
        tblMtr = new javax.swing.JTable();
        btnOther = new javax.swing.JButton();
        btnAddOrder = new javax.swing.JButton();
        txtDateTime = new javax.swing.JTextField();
        pnlPay = new javax.swing.JPanel();
        pnlPayTable = new javax.swing.JPanel();
        scpPayList = new javax.swing.JScrollPane();
        tblPayment = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        btnIncrease = new javax.swing.JButton();
        btnDecrease = new javax.swing.JButton();
        btnRemove = new javax.swing.JButton();
        pnlInfo = new javax.swing.JPanel();
        lblTotal = new javax.swing.JLabel();
        txtTotal = new javax.swing.JTextField();
        btnPrint = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();
        lblTotalTitle = new javax.swing.JLabel();

        pnlMtrTable.setBackground(new java.awt.Color(255, 255, 255));

        scpMtrTable.setBackground(new java.awt.Color(255, 255, 255));
        scpMtrTable.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(84, 70, 63), 2, true));
        scpMtrTable.setForeground(new java.awt.Color(84, 70, 63));
        scpMtrTable.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N

        tblMtr.setBackground(new java.awt.Color(255, 255, 255));
        tblMtr.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        tblMtr.setForeground(new java.awt.Color(84, 70, 63));
        tblMtr.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "รหัสวัตถุดิบ", "ชื่อวัตถุดิบ", "ราคาวัตถุดิบ"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblMtr.setRowHeight(50);
        tblMtr.setSelectionBackground(new java.awt.Color(84, 70, 63));
        tblMtr.setSelectionForeground(new java.awt.Color(255, 255, 255));
        tblMtr.setShowGrid(false);
        scpMtrTable.setViewportView(tblMtr);

        btnOther.setBackground(new java.awt.Color(85, 68, 68));
        btnOther.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        btnOther.setForeground(new java.awt.Color(255, 255, 255));
        btnOther.setText("อื่นๆ");
        btnOther.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOtherActionPerformed(evt);
            }
        });

        btnAddOrder.setBackground(new java.awt.Color(85, 68, 68));
        btnAddOrder.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        btnAddOrder.setForeground(new java.awt.Color(255, 255, 255));
        btnAddOrder.setText("เพิ่ม");
        btnAddOrder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddOrderActionPerformed(evt);
            }
        });

        txtDateTime.setBackground(new java.awt.Color(255, 255, 255));
        txtDateTime.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        txtDateTime.setForeground(new java.awt.Color(84, 70, 63));
        txtDateTime.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtDateTime.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(84, 70, 63)));
        txtDateTime.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtDateTimeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnlMtrTableLayout = new javax.swing.GroupLayout(pnlMtrTable);
        pnlMtrTable.setLayout(pnlMtrTableLayout);
        pnlMtrTableLayout.setHorizontalGroup(
            pnlMtrTableLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlMtrTableLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlMtrTableLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlMtrTableLayout.createSequentialGroup()
                        .addComponent(scpMtrTable, javax.swing.GroupLayout.DEFAULT_SIZE, 810, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(pnlMtrTableLayout.createSequentialGroup()
                        .addComponent(txtDateTime, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnAddOrder, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnOther, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(14, 14, 14))))
        );
        pnlMtrTableLayout.setVerticalGroup(
            pnlMtrTableLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlMtrTableLayout.createSequentialGroup()
                .addGap(8, 8, 8)
                .addGroup(pnlMtrTableLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(txtDateTime, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlMtrTableLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(btnOther, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnAddOrder, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(scpMtrTable)
                .addContainerGap())
        );

        pnlPay.setBackground(new java.awt.Color(255, 255, 255));
        pnlPay.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(102, 102, 102)));
        pnlPay.setForeground(new java.awt.Color(102, 102, 102));

        pnlPayTable.setBackground(new java.awt.Color(211, 197, 186));
        pnlPayTable.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(119, 76, 29), 2, true));

        scpPayList.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(84, 70, 63), 1, true));

        tblPayment.setBackground(new java.awt.Color(255, 255, 255));
        tblPayment.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        tblPayment.setForeground(new java.awt.Color(84, 70, 63));
        tblPayment.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "รายการ", "จำนวน", "มูลค่า", "รวม"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblPayment.setSelectionBackground(new java.awt.Color(84, 70, 63));
        tblPayment.setSelectionForeground(new java.awt.Color(255, 255, 255));
        tblPayment.setShowGrid(false);
        scpPayList.setViewportView(tblPayment);
        if (tblPayment.getColumnModel().getColumnCount() > 0) {
            tblPayment.getColumnModel().getColumn(0).setResizable(false);
            tblPayment.getColumnModel().getColumn(2).setResizable(false);
        }

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 24)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(84, 70, 63));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("รายการ");

        btnIncrease.setBackground(new java.awt.Color(85, 68, 68));
        btnIncrease.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        btnIncrease.setForeground(new java.awt.Color(255, 255, 255));
        btnIncrease.setText("+");
        btnIncrease.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnIncreaseActionPerformed(evt);
            }
        });

        btnDecrease.setBackground(new java.awt.Color(85, 68, 68));
        btnDecrease.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        btnDecrease.setForeground(new java.awt.Color(255, 255, 255));
        btnDecrease.setText("-");
        btnDecrease.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDecreaseActionPerformed(evt);
            }
        });

        btnRemove.setBackground(new java.awt.Color(85, 68, 68));
        btnRemove.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        btnRemove.setForeground(new java.awt.Color(255, 255, 255));
        btnRemove.setText("ยกเลิกรายการ");
        btnRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemoveActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnlPayTableLayout = new javax.swing.GroupLayout(pnlPayTable);
        pnlPayTable.setLayout(pnlPayTableLayout);
        pnlPayTableLayout.setHorizontalGroup(
            pnlPayTableLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPayTableLayout.createSequentialGroup()
                .addGroup(pnlPayTableLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlPayTableLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(scpPayList, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                    .addGroup(pnlPayTableLayout.createSequentialGroup()
                        .addGap(171, 171, 171)
                        .addComponent(jLabel1)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlPayTableLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(btnIncrease, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 14, Short.MAX_VALUE)
                        .addComponent(btnDecrease, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(214, 214, 214)
                        .addComponent(btnRemove, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        pnlPayTableLayout.setVerticalGroup(
            pnlPayTableLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlPayTableLayout.createSequentialGroup()
                .addGap(15, 15, 15)
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(scpPayList, javax.swing.GroupLayout.DEFAULT_SIZE, 321, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addGroup(pnlPayTableLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlPayTableLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(btnIncrease, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btnDecrease, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(btnRemove, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(22, 22, 22))
        );

        pnlInfo.setBackground(new java.awt.Color(211, 197, 186));
        pnlInfo.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(119, 76, 29), 2, true));

        lblTotal.setFont(new java.awt.Font("Tahoma", 1, 24)); // NOI18N
        lblTotal.setForeground(new java.awt.Color(84, 70, 63));
        lblTotal.setText("รวม :");

        txtTotal.setBackground(new java.awt.Color(211, 197, 186));
        txtTotal.setFont(new java.awt.Font("Tahoma", 1, 24)); // NOI18N
        txtTotal.setForeground(new java.awt.Color(84, 70, 63));
        txtTotal.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtTotal.setBorder(null);

        javax.swing.GroupLayout pnlInfoLayout = new javax.swing.GroupLayout(pnlInfo);
        pnlInfo.setLayout(pnlInfoLayout);
        pnlInfoLayout.setHorizontalGroup(
            pnlInfoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlInfoLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblTotal)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtTotal)
                .addContainerGap())
        );
        pnlInfoLayout.setVerticalGroup(
            pnlInfoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlInfoLayout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addGroup(pnlInfoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblTotal, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txtTotal, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(40, Short.MAX_VALUE))
        );

        btnPrint.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        btnPrint.setText("พิมพ์");
        btnPrint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPrintActionPerformed(evt);
            }
        });

        btnCancel.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        btnCancel.setText("ยกเลิก");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        lblTotalTitle.setFont(new java.awt.Font("Tahoma", 1, 26)); // NOI18N
        lblTotalTitle.setForeground(new java.awt.Color(84, 70, 63));
        lblTotalTitle.setText("รายการ");

        javax.swing.GroupLayout pnlPayLayout = new javax.swing.GroupLayout(pnlPay);
        pnlPay.setLayout(pnlPayLayout);
        pnlPayLayout.setHorizontalGroup(
            pnlPayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPayLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlPayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlPayLayout.createSequentialGroup()
                        .addGroup(pnlPayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(pnlInfo, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(pnlPayTable, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addContainerGap())
                    .addGroup(pnlPayLayout.createSequentialGroup()
                        .addGroup(pnlPayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(pnlPayLayout.createSequentialGroup()
                                .addComponent(btnCancel, javax.swing.GroupLayout.PREFERRED_SIZE, 206, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(btnPrint, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(pnlPayLayout.createSequentialGroup()
                                .addComponent(lblTotalTitle)
                                .addGap(0, 0, Short.MAX_VALUE)))
                        .addGap(6, 6, 6))))
        );
        pnlPayLayout.setVerticalGroup(
            pnlPayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPayLayout.createSequentialGroup()
                .addComponent(lblTotalTitle, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pnlPayTable, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(pnlInfo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(pnlPayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnPrint, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnCancel, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(pnlMtrTable, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pnlPay, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(1, 1, 1))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(pnlMtrTable, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlPay, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    public void getDateTime() {
        txtDateTime.setEditable(false);
        Timer timer;
        ActionListener actionListener = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Date date = new Date();
                DateFormat timeFormat = new SimpleDateFormat("HH:mm:ss");
                String time = timeFormat.format(date);

                Date date2 = new Date();
                DateFormat timeFormat2 = new SimpleDateFormat("dd-MM-yyyy");
                String time2 = timeFormat2.format(date2);
                txtDateTime.setText(time2 + " " + time);
            }
        };
        timer = new Timer(1000, actionListener);
        timer.setInitialDelay(0);
        timer.start();
    }
    private void btnIncreaseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnIncreaseActionPerformed
        int updateRow = tblPayment.getSelectedRow();
        if (updateRow >= 0) {
            double total = Double.parseDouble(tblPayment.getValueAt(updateRow, 3).toString());
            if (updateRow >= 0) {
                int amount = (int) tblPayment.getValueAt(updateRow, 1);
                tblPayment.setValueAt(amount + 1, updateRow, 1);
                tblPayment.setValueAt((total / amount) * (amount + 1), updateRow, 3);
                setTotal();
            }
        }
    }//GEN-LAST:event_btnIncreaseActionPerformed

    private void btnDecreaseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDecreaseActionPerformed
        int updateRow = tblPayment.getSelectedRow();
        if (updateRow >= 0) {
            double total = Double.parseDouble(tblPayment.getValueAt(updateRow, 3).toString());
            if (updateRow >= 0) {
                int amount = (int) tblPayment.getValueAt(updateRow, 1);
                if (amount > 1) {
                    tblPayment.setValueAt(amount - 1, updateRow, 1);
                    tblPayment.setValueAt((total / amount) * (amount - 1), updateRow, 3);
                    setTotal();
                }
            }
        }
    }//GEN-LAST:event_btnDecreaseActionPerformed

    private void btnRemoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemoveActionPerformed
        int removeCol = tblPayment.getSelectedRow();
        if (removeCol >= 0) {
            PayModel.removeRow(removeCol);
            setTotal();
        }
    }//GEN-LAST:event_btnRemoveActionPerformed

    private void btnPrintActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPrintActionPerformed
        if (tblPayment.getRowCount() > 0) {
            MessageFormat header = new MessageFormat("รายการค่าใช้จ่าย ");
            MessageFormat footer = new MessageFormat("หน้าที่ {0, number, integer}");

            try {
                tblPayment.print(JTable.PrintMode.NORMAL, header, footer);
                PayModel.setRowCount(0);
                setTotal();
            } catch (java.awt.print.PrinterException e) {
                JOptionPane.showMessageDialog(null, "ไม่สามารถพิมพ์รายการได้ เนื่องจากไม่พบเครื่องพิมพ์", "ไม่พบเครื่องพิมพ์", JOptionPane.INFORMATION_MESSAGE);
            }
        } else {
            JOptionPane.showMessageDialog(null, "ไม่สามารถพิมพ์รายการได้ เนื่องจากรายการยังว่างอยู่", "ไม่สามารถพิมพ์รายการได้", JOptionPane.INFORMATION_MESSAGE);
        }
    }//GEN-LAST:event_btnPrintActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        if (tblPayment.getRowCount() > 0) {
            int result = JOptionPane.showConfirmDialog(null, "ต้องการยกเลิกรายการปัจจุบันหรือไม่ ?", "ยืนยันการยกเลิกรายการ",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.WARNING_MESSAGE);
            if (result == JOptionPane.YES_OPTION) {
                PayModel.setRowCount(0);
                setTotal();
            }
        } else {
            JOptionPane.showMessageDialog(null, "ไม่สามารถยกเลิกรายการได้ เนื่องจากรายการยังว่างอยู่", "ไม่สามารถยกเลิกรายการได้", JOptionPane.INFORMATION_MESSAGE);
        }
    }//GEN-LAST:event_btnCancelActionPerformed

    private void btnOtherActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOtherActionPerformed
        CreateCustomPay createCustomPay = new CreateCustomPay();
        createCustomPay.setVisible(true);
        createCustomPay.setResizable(false);
        createCustomPay.setLocationRelativeTo(null);
        createCustomPay.setMinimumSize(null);
        createCustomPay.setCashPanel(this);
    }//GEN-LAST:event_btnOtherActionPerformed

    private void btnAddOrderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddOrderActionPerformed
        int selectedRow = tblMtr.getSelectedRow();
        if (selectedRow >= 0) {
            PayModel.addRow(new Object[]{mtrList.get(selectedRow).getMtrName(), 1, mtrList.get(selectedRow).getMtrPrice(), mtrList.get(selectedRow).getMtrPrice()});
            setTotal();
        }
    }//GEN-LAST:event_btnAddOrderActionPerformed

    private void txtDateTimeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtDateTimeActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtDateTimeActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddOrder;
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnDecrease;
    private javax.swing.JButton btnIncrease;
    private javax.swing.JButton btnOther;
    private javax.swing.JButton btnPrint;
    private javax.swing.JButton btnRemove;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel lblTotal;
    private javax.swing.JLabel lblTotalTitle;
    private javax.swing.JPanel pnlInfo;
    private javax.swing.JPanel pnlMtrTable;
    private javax.swing.JPanel pnlPay;
    private javax.swing.JPanel pnlPayTable;
    private javax.swing.JScrollPane scpMtrTable;
    private javax.swing.JScrollPane scpPayList;
    private javax.swing.JTable tblMtr;
    private javax.swing.JTable tblPayment;
    private javax.swing.JTextField txtDateTime;
    private javax.swing.JTextField txtTotal;
    // End of variables declaration//GEN-END:variables

    void setPay(String pay, String payPrice) {
        PayModel.addRow(new Object[]{pay, 1, Double.parseDouble(payPrice), Double.parseDouble(payPrice)});
        setTotal();
    }

    public void setTotal() {
        double sum = 0;
        for (int i = 0; i < tblPayment.getRowCount(); i++) {
            sum = sum + Double.parseDouble(tblPayment.getValueAt(i, 3).toString());
        }
        txtTotal.setText(Double.toString(sum));
    }

}
